%define 	pname yum-headers
%define 	pversion 1.0
%define 	bversion 100
%define 	rpmrelease iworx
%define		yumcachedir /var/cache/yum

%define 	debug_package %{nil}

%define		with_dag 0
%{?_with_dag:   %{expand: %%define with_dag 1}}

%define		with_freshrpms 0
%{?_with_freshrpms:   %{expand: %%define with_freshrpms 1}}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
Obsoletes:	centos-yumcache
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise  2.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise  3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise  4.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	InterWorx-CP yum.conf
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	GPL

Group:		System Environment/Base

Distribution:	InterWorx-HAL
Vendor:		NEXCESS.NET L.L.C.
Packager:	NEXCESS.NET L.L.C. <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Requires:	yum

%description
This is the headers for yum so they won't have to be downloaded 
when yum is initially run.

#%prep

#%setup

%build

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

export CPPFLAGS=""
export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC $CPPFLAGS"

##
## build the headers

%if %{build_rhe_3x}
	yum \
	-c http://updates.interworx.info/iworx/ks/yum-rhe3x.conf \
	check-update || :
%else
	yum check-update || :
%endif

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# base shizzle for all plats
mkdir -p %{buildroot}%{yumcachedir}/base
cp -auR %{yumcachedir}/base/headers \
	%{buildroot}%{yumcachedir}/base
cp %{yumcachedir}/base/header.info \
	%{buildroot}%{yumcachedir}/base/

# DAG shizzle
%if %{with_dag}
	mkdir -p %{buildroot}%{yumcachedir}/dag
	cp -auR %{yumcachedir}/dag/headers \
		%{buildroot}%{yumcachedir}/dag
	cp %{yumcachedir}/dag/header.info \
		%{buildroot}%{yumcachedir}/dag/
%endif

# FRESHRPMS shizzle
%if %{with_freshrpms}
	mkdir -p %{buildroot}%{yumcachedir}/freshrpms
	cp -auR %{yumcachedir}/freshrpms/headers \
		%{buildroot}%{yumcachedir}/freshrpms
	cp %{yumcachedir}/freshrpms/header.info \
		%{buildroot}%{yumcachedir}/freshrpms/
%endif

# RHT90 needs fedora legacy shit instead of "updates"
# all others need "udpates"
%if %{build_rht_90}
	mkdir -p %{buildroot}%{yumcachedir}/fedora-legacy-updates
	cp -auR %{yumcachedir}/fedora-legacy-updates/headers \
		%{buildroot}%{yumcachedir}/fedora-legacy-updates
	mv %{yumcachedir}/fedora-legacy-updates/header.info \
		%{buildroot}%{yumcachedir}/fedora-legacy-updates/
%else
	%if %{build_rhe_3x} || %{build_rhe_4x}

	%else
		mkdir -p %{buildroot}%{yumcachedir}/updates
		cp -auR %{yumcachedir}/updates/headers \
			%{buildroot}%{yumcachedir}/updates
		mv %{yumcachedir}/updates/header.info \
			%{buildroot}%{yumcachedir}/updates/
	%endif
%endif

# COS3X also has some extra respositories
%if %{build_cos_3x}
	mkdir -p %{buildroot}%{yumcachedir}/addons
	cp -auR %{yumcachedir}/addons/headers \
		%{buildroot}%{yumcachedir}/addons
	mv %{yumcachedir}/addons/header.info \
		%{buildroot}%{yumcachedir}/addons/

	mkdir -p %{buildroot}%{yumcachedir}/extras
	cp -auR %{yumcachedir}/extras/headers \
 		%{buildroot}%{yumcachedir}/extras
	mv %{yumcachedir}/extras/header.info \
		%{buildroot}%{yumcachedir}/extras/
%endif

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%files
%defattr(-,root,root)
%attr(0644,root,root) %{yumcachedir}/base/headers
%attr(0644,root,root) %{yumcachedir}/base/header.info

%if %{with_dag}
	%attr(0644,root,root) %{yumcachedir}/dag/headers
	%attr(0644,root,root) %{yumcachedir}/dag/header.info
%endif

%if %{with_freshrpms}
	%attr(0644,root,root) %{yumcachedir}/freshrpms/headers
	%attr(0644,root,root) %{yumcachedir}/freshrpms/header.info
%endif

%if %{build_rht_90}
	%attr(0644,root,root) %{yumcachedir}/fedora-legacy-updates/headers
	%attr(0644,root,root) %{yumcachedir}/fedora-legacy-updates/header.info
%else
	%if %{build_rhe_3x} || %{build_rhe_4x}

	%else
		%attr(0644,root,root) %{yumcachedir}/updates/headers
		%attr(0644,root,root) %{yumcachedir}/updates/header.info
	%endif
%endif

%if %{build_cos_3x}
	%attr(0644,root,root) %{yumcachedir}/addons/headers
	%attr(0644,root,root) %{yumcachedir}/addons/header.info
	%attr(0644,root,root) %{yumcachedir}/extras/headers
	%attr(0644,root,root) %{yumcachedir}/extras/header.info
%endif

%changelog
* Tue Feb 23 2005 Chris Wells <clwells@nexcess.net>
- Updated for RHEL 4
* Sun Feb 06 2005 Chris Wells <clwells@nexcess.net>
- Added DAG / FreshRPM support
* Sun May 30 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
